<?php
/*
Main class for Parasite

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 04-04-2019
*/
class GenContent{
	var $sEmail = "doesntexist@oi.oi";
	var $sPass = "tralalala";
	var $rConnect = "";
	var $sTable = "";
	var $sTablePrefix = "";
	var $sProduct = "";
	var $iVersion = "";
	var $sLastError = "";
	var $aFile = "";
	var $iFile = "";
	// set connection
	function SetConnect($rConnect){
		$this->rConnect = $rConnect;
	}
	// get connection
	function GetConnect(){
		return($this->rConnect);
	}
	// set email address
	function SetEmail($sEmail){
		$this->sEmail = $sEmail;
	}
	// get email address
	function GetEmail(){
		return($this->sEmail);
	}
	// set account password
	function SetPass($sPass){
		$this->sPass = $sPass;
	}
	// get account password
	function GetPass(){
		return($this->sPass);
	}
	// set last error
	function SetLastError($sError){
		$this->sLastError = $sError;
	}
	// get last error
	function GetLastError(){
		return($this->sLastError);
	}
	// set software product
	function SetProduct($sProduct){
		$this->sProduct = $sProduct;
	}
	// get software product
	function GetProduct(){
		return($this->sProduct);
	}
	// set software version
	function SetVersion($iVersion){
		$this->sProduct = $iVersion;
	}
	// get software version
	function GetVersion(){
		return($this->iVersion);
	}
	// set table
	function SetTable($sTable){
		$this->sTable = $sTable;
	}
	// get table
	function GetTable(){
		return($this->sTable);
	}
	// set table prefix
	function SetPrefix($sPrefix){
		$this->sTablePrefix = $sPrefix;
	}
	// get table prefix
	function GetPrefix(){
		return($this->sTablePrefix);
	}
	// get amount of accounts in username file
	function GetAmountAccounts(){
		return($this->iFile);
	}
	// set amount of accounts in username file
	function SetAmountAccounts($iFile){
		$this->iFile = $iFile;
	}
	// connects to a database
	function ConnectDB($sHost,$sDatabase,$sUser,$sPass){
		$rConnect = @mysqli_connect($sHost,$sUser,$sPass,$sDatabase);
		if(!mysqli_connect_errno()){
			$this->SetConnect($rConnect);
			return(true);
		}
		else{
			$this->SetLastError("Failed to connect to database");
			return(false);
		}
	}
	// gets directory names in a directory
	function GetDirByDir($sParentDir){
		if(!$rHandle = @opendir($sParentDir)){
			$this->SetLastError("Failed to open directory ".$sParentDir);
			return(false);
		}
		$aDirBuffer = array();
		while(false!==($sDir = @readdir($rHandle))){
			if($sDir=="." || $sDir==".."){
				continue;
			}
			$sPath = $sParentDir."/".$sDir;
			if(@is_dir($sPath)){
				// buffers subdirectories
				$aDirBuffer[] = $sDir;
			}
		}
		@closedir($rHandle);
		return($aDirBuffer);
	}
	// gets username file and stores it in an array
	function GetUsers($sUsernameFile){
		$this->aFile = @file($sUsernameFile);
		if(false==($this->iFile = count($this->aFile))){
			$this->SetLastError("No usernames in ".$sUsernameFile);
			return(false);
		}
		return(true);
	}
	// filters username file and overwrites it
	function TruncateUsernameFile($sFile){
		if(!file_exists($sFile)){
			$this->SetLastError("Username file ".$sUsernameFile." doesn't exist");
			return(false);
		}
		$aFile = @file($sFile);
		$sData = "";
		for($x=0;$x<count($aFile);$x++){
			$aFile[$x] = trim($aFile[$x]);
			if(strlen($aFile[$x])<7){
				continue;
			}
			if(strlen($aFile[$x])>12){
				continue;
			}
			if(preg_match('/^[0-9]+$/',$aFile[$x])){
				continue;
			}
			if(strpos($aFile[$x],".")>0){
				continue;
			}
			$sData .= $aFile[$x]."\n";
		}
		if(!$this->WriteF($sFile,$sData,"w")){
			return(false);
		}
		return(true);
	}
	// gets an array of supported products and versions
	function GetSupportedProducts($sPath=""){
		$aProducts = array();
		$sDir = $sPath."classes/";
		if(false==($aClassDirs = $this->GetDirByDir($sDir))){
			return(false);
		}
		for($x=0;$x<count($aClassDirs);$x++){
			if(false==($aSubDirs = $this->GetDirByDir($sDir."/".$aClassDirs[$x]))){
				continue;
			}
			$aDirs[$aClassDirs[$x]] = $aSubDirs;
		}
		return($aDirs);
	}
	// checks if a supported product and version is valid
	function IsSupportedProduct($aProducts,$sProduct,$iVersion){
		foreach($aProducts as $sProductName=>$aVersions){
			if($sProductName==$sProduct){
				if(in_array($iVersion,$aVersions)){
					return(true);
				}
			}
		}
		return(false);
	}
	// generate account settings for connecting to a database
	function GenerateSettings($aCurrentData,$aNewData){
		if($aNewData['profile_name']==""){
			// no profile name
			$this->SetLastError("No profile name set");
			return(false);
		}
		$sBuffer = "<?php\n";
		$sBuffer .= "\$aAccounts = array();\n";
		$sBuffer .= "\$aAccounts[0] = array();\n";
		$sBuffer .= "\$aAccounts[0]['profile_name'] = \"".$aNewData['profile_name']."\";\n";
		$sBuffer .= "// if not empty, this will override the variable \$aParasite['table']\n";
		$sBuffer .= "\$aAccounts[0]['database_table_users'] = \"".$aNewData['database_table_users']."\";\n";
		$sBuffer .= "\$aAccounts[0]['database_table_prefix'] = \"".$aNewData['database_table_prefix']."\";\n";
		$sBuffer .= "\$aAccounts[0]['database_user'] = \"".$aNewData['database_user']."\";\n";
		$sBuffer .= "\$aAccounts[0]['database_pass'] = \"".$aNewData['database_pass']."\";\n";
		$sBuffer .= "\$aAccounts[0]['database_name'] = \"".$aNewData['database_name']."\";\n";
		$sBuffer .= "\$aAccounts[0]['database_host'] = \"".$aNewData['database_host']."\";\n";
		$sBuffer .= "\$aAccounts[0]['database_backup'] = \"".$aNewData['database_backup']."\";\n";
		if(isset($aCurrentData[0]) && $aCurrentData!=false){
			// add other accounts
			for($x=0;$x<count($aCurrentData);$x++){
				if(isset($aCurrentData[($x+1)]['profile_name']) && $aCurrentData[($x+1)]['profile_name']==$aNewData['profile_name']){
					// profile already exists
					$this->SetLastError("Profile name already exists");
					return(false);
				}
				$sBuffer .= "\$aAccounts[".($x+1)."] = array();\n";
				$sBuffer .= "\$aAccounts[".($x+1)."]['profile_name'] = \"".$aCurrentData[$x]['profile_name']."\";\n";
				$sBuffer .= "// if not empty, this will override the variable \$aParasite['table']\n";
				$sBuffer .= "\$aAccounts[".($x+1)."]['database_table_users'] = \"".$aCurrentData[$x]['database_table_users']."\";\n";
				$sBuffer .= "\$aAccounts[".($x+1)."]['database_table_prefix'] = \"".$aCurrentData[$x]['database_table_prefix']."\";\n";
				$sBuffer .= "\$aAccounts[".($x+1)."]['database_user'] = \"".$aCurrentData[$x]['database_user']."\";\n";
				$sBuffer .= "\$aAccounts[".($x+1)."]['database_pass'] = \"".$aCurrentData[$x]['database_pass']."\";\n";
				$sBuffer .= "\$aAccounts[".($x+1)."]['database_name'] = \"".$aCurrentData[$x]['database_name']."\";\n";
				$sBuffer .= "\$aAccounts[".($x+1)."]['database_host'] = \"".$aCurrentData[$x]['database_host']."\";\n";
				$sBuffer .= "\$aAccounts[".($x+1)."]['database_backup'] = \"".$aCurrentData[$x]['database_backup']."\";\n";
			}
		}
		$sBuffer .= "?>";
		return($sBuffer);		
	}
	// get current profile settings for a software product
	function GetSettings($sFile){
		if(!file_exists($sFile)){
			return(false);
		}
		@include($sFile);
		if(!@count($aAccounts)){
			return(false);
		}
		return($aData);
	}
	// pick a random user from a username file
	function MakeUser(){
		$sUser = @trim($this->aFile[mt_rand(0,$this->iFile-1)]);
		return($sUser);
	}
	// generates insert query
	function InsertQuery($aQuery){
		$sQuery = "INSERT INTO ".$this->GetPrefix().$this->GetTable()." (";
		$sKeys = "";
		$sValues = "";
		foreach($aQuery as $sKey=>$sValue){
			$sKeys .= $sKey.",";
			$sValues .= "\"".$sValue."\",";
		}
		$sKeys = substr($sKeys,0,-1);
		$sValues = substr($sValues,0,-1);
		$sQuery .= $sKeys.") VALUES (".$sValues.")";
		if(false===($rQuery = @mysqli_query($this->rConnect,$sQuery))){
			return(false);
		}
		return(true);
	}
	// test if table properties are correct
	function TestQuery($aData,$sTable,$sPrefix=""){
		$sQuery = "SELECT ";
		$x = 0;
		foreach($aData as $sKey=>$sValue){
			if($x!=0){
				$sQuery .= ",";
			}
			$sQuery .= $sValue;
			$x++;
		}
		$sQuery .= " FROM ".$this->GetPrefix().$this->GetTable()." LIMIT 1";
		if(false==($rQuery = @mysqli_query($this->rConnect,$sQuery))){
			return(false);
		}
		return(mysqli_num_rows($rQuery));
	}
	// extract users from a table
	function ExtractUsers($aFields,$aUsers=""){
		$sQuery = "SELECT ";
		$x = 0;
		foreach($aFields as $sKey=>$sValue){
			if($x!=0){
				$sQuery .= ",";
			}
			$sQuery .= $sValue;
			$x++;
		}
		$sQuery .= " FROM ".$this->GetPrefix().$this->GetTable();
		if($aUsers!=""){
			$sQuery .= " WHERE ";
			for($x=0;$x<count($aUsers);$x++){
				if($x!=0){
					$sQuery .= " OR ";
				}
				$sQuery .= $aFields['userid']."=".$aUsers[$x];
			}
		}
		if(false==($rQuery = mysqli_query($this->rConnect,$sQuery))){
			return(false);
		}
		$aData = array();
		while($aRow = mysqli_fetch_assoc($rQuery)){
			$aData[] = $aRow;
		}
		return($aData);
	}
	// recover accounts
	function RecoverData($aData,$sUserIDFieldName){
		$sQuery = "UPDATE ".$this->GetPrefix().$this->GetTable()." SET ";
		// set field values
		$iUser = 0;
		foreach($aData as $sKey=>$sValue){
			if($sUserIDFieldName==$sKey){
				$iUser = $sValue;
				continue;
			}
			$sQuery .= $sKey."='".$sValue."',";
		}
		$sQuery = substr($sQuery,0,-1);
		// set where statement or discard
		if(!$iUser){
			return(false);
		}
		$sQuery .= " WHERE ".$sUserIDFieldName."=".$iUser;
		$rQuery = mysqli_query($this->rConnect,$sQuery);
		return(mysqli_affected_rows($this->rConnect));
	}
	// writes or overwrites a file
	function WriteF($sDest,$sWrite,$sMode="a"){
		if($sMode!="a" && $sMode!="w"){
			$sMode = "a";
		}
		if(!$rNew = @fopen($sDest,$sMode)){
			// failed to create, or write to, file
			$this->SetLastError("Failed to write to ".$sDest);
			return(false);
		}
		@fputs($rNew,$sWrite);
		@fclose($rNew);
		return(true);
	}
	// generates a random ip address
	function MakeIP(){
		return(mt_rand(25,200).".".mt_rand(25,200).".".mt_rand(25,200).".".mt_rand(25,200));
	}
	// generates a random string
	function RandomString($iLength){
		$sBuffer = "";
		$sText = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
		for($x=0;$x<$iLength;$x++){
			$sBuffer .= $sText[mt_rand(0,strlen($sText)-1)];
		}
		return($sBuffer);
	}
	// creates a random number
	function RandomNumber($iStar,$iEnd){
		return(mt_rand($iStar,$iEnd));
	}
}
?>