<?php
/* Recover one or more accounts

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 29-06-2017
*/
if(!defined('IN_SCRIPT')){
	exit;
}
$bProceed = false;
$aAccounts = array();
$iProfile = 0;
if(@filesize($sDestAccounts)!=false){
	// there are accounts that we can use for validation
	include($sDestAccounts);
	for($x=0;$x<count($aAccounts);$x++){
		if($aAccounts[$x]['profile_name']==$_POST['sProfileName']){
			$bProceed = true;
			$aAccounts = $aAccounts[$x];
			$iProfile = $x;
			break;
		}
	}
	if($bProceed){
		if(!$cGen->ConnectDB($aAccounts['database_host'],$aAccounts['database_name'],$aAccounts['database_user'],$aAccounts['database_pass'])){
			$aDataR['jmessage'] = "Please check your credentials, failed to connect to database";
			$bProceed = false;
		}
	}
}
if($bProceed){
	// get the backup file and return accounts to their original state
	if($aAccounts['database_backup']==""){
		$aDataR['jmessage'] = "No database backup folder has been created yet";
	}
	else{
		if(!preg_match('/^[0-9]+\.txt$/',$_POST['sFileX'])){
			$aDataR['jmessage'] = "Invalid file name, files should start with a timestamp and have a txt extension";
		}
		else{
			$sDest = "../backup/".$aProduct[0]."/".$aProduct[1]."/".$aAccounts['database_backup']."/".$_POST['sFileX'];
			if(!file_exists($sDest)){
				$aDataR['jmessage'] = "Specified file doesn't exist";
			}
			else{
				// turn back the data into its original form
				$sData = @file_get_contents($sDest);
				$aData = @unserialize($sData);
				if(!is_array($aData)){
					$aDataR['jmessage'] = "Invalid serialized data in file";
				}
				else{
					if(false==($iData = count($aData))){
						$aDataR['jmessage'] = "No valid data found in backup";
					}
					else{
						// set correct table name
						$cGen->SetPrefix($aAccounts['database_table_prefix']);
						$cGen->SetTable($aAccounts['database_table_users']);
						include($sDestDBFields);
						// update account data in database
						$iErrors = 0;
						for($x=0;$x<$iData;$x++){
							if(!$cGen->RecoverData($aData[$x],$aParasite['fields']['userid'])){
								$iErrors++;
							}
						}
						if($iErrors>0){
							// in this case you will have to manually recover the accounts
							$aDataR['jmessage'] = "One or more accounts didn't recover (".$iErrors."/".$iData.")";
						}
						else{
							$aDataR['jmessage'] = "Successfully recovered table";
							$aDataR['jresult'] = true;
						}
					}
				}
			}
		}
	}
}
else{
	$aDataR['jmessage'] = "Profile doesn't exist";
}
?>