<?php
/*
Headers for all media types

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 12-11-2014
*/
if(!defined("IN_SCRIPT")){
	exit;
}
$_CONTEXT['media'] = "<select name=\"sMedia\">\n";
$_CONTEXT['media'] .= "<optgroup label=\"Multipurpose Files\">\n";
$_CONTEXT['media'] .= "<option value=\"application/atom+xml\">Atom feeds</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/ecmascript\">ECMAScript/JavaScript</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/EDI-X12\">EDI X12 data; Defined in RFC 1767</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/EDIFACT\">EDI EDIFACT data; Defined in RFC 1767</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/json\">JavaScript Object Notation JSON; Defined in RFC 4627</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/javascript\">ECMAScript/JavaScript; Defined in RFC 4329</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/octet-stream\">Arbitrary binary data.</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/ogg\">Ogg, a multimedia bitstream container format</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/pdf\">Portable Document Format</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/postscript\">PostScript; Defined in RFC 2046</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/rdf+xml\">Resource Description Framework</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/rss+xml\">RSS feeds</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/soap+xml\">SOAP; Defined by RFC 3902</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/font-woff\">Web Open Font Format</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/xhtml+xml\">XHTML; Defined by RFC 3236</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/xml\">XML files; Defined by RFC 3023</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/xml-dtd\">DTD files; Defined by RFC 3023</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/xop+xml\">XOP</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/zip\">ZIP archive files</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/gzip\">Gzip, Defined in RFC 6713</option>\n";
$_CONTEXT['media'] .= "</optgroup>\n";
$_CONTEXT['media'] .= "<optgroup label=\"Audio\">\n";
$_CONTEXT['media'] .= "<option value=\"audio/basic\">μ-law audio at 8 kHz, 1 channel; Defined in RFC 2046</option>\n";
$_CONTEXT['media'] .= "<option value=\"audio/L24\">24bit Linear PCM audio at 8–48 kHz, 1-N channels</option>\n";
$_CONTEXT['media'] .= "<option value=\"audio/mp4\">MP4 audio</option>\n";
$_CONTEXT['media'] .= "<option value=\"audio/mpeg\">MP3 or other MPEG audio; Defined in RFC 3003</option>\n";
$_CONTEXT['media'] .= "<option value=\"audio/ogg\">Ogg Vorbis, Speex, Flac and other audio; Defined in RFC 5334</option>\n";
$_CONTEXT['media'] .= "<option value=\"audio/vorbis\">Vorbis encoded audio; Defined in RFC 5215</option>\n";
$_CONTEXT['media'] .= "<option value=\"audio/vnd.rn-realaudio\">RealAudio; Documented in RealPlayer Help</option>\n";
$_CONTEXT['media'] .= "<option value=\"audio/vnd.wave\">WAV audio; Defined in RFC 2361</option>\n";
$_CONTEXT['media'] .= "<option value=\"audio/webm\">WebM open media format</option>\n";
$_CONTEXT['media'] .= "</optgroup>\n";
$_CONTEXT['media'] .= "<optgroup label=\"Image\">\n";
$_CONTEXT['media'] .= "<option value=\"image/gif\">GIF image; Defined in RFC 2045 and RFC 2046</option>\n";
$_CONTEXT['media'] .= "<option value=\"image/jpeg\">JPEG JFIF image; Defined in RFC 2045 and RFC 2046</option>\n";
$_CONTEXT['media'] .= "<option value=\"image/pjpeg\">JPEG JFIF image; Progressive - pjpeg</option>\n";
$_CONTEXT['media'] .= "<option value=\"image/svg+xml\">SVG vector image; Defined in SVG Tiny 1.2 Specification Appendix M</option>\n";
$_CONTEXT['media'] .= "<option value=\"image/tiff\">Tag Image File Format (only for Baseline TIFF); Defined in RFC 3302</option>\n";
$_CONTEXT['media'] .= "</optgroup>\n";
$_CONTEXT['media'] .= "<optgroup label=\"Message\">\n";
$_CONTEXT['media'] .= "<option value=\"message/http\">Defined in RFC 2616</option>\n";
$_CONTEXT['media'] .= "<option value=\"message/imdn+xml\">IMDN Instant Message Disposition Notification; Defined in RFC 5438</option>\n";
$_CONTEXT['media'] .= "<option value=\"message/partial\">Email; Defined in RFC 2045 and RFC 2046</option>\n";
$_CONTEXT['media'] .= "<option value=\"message/rfc822\">Email; EML files, MIME files, MHT files, MHTML files</option>\n";
$_CONTEXT['media'] .= "</optgroup>\n";
$_CONTEXT['media'] .= "<optgroup label=\"3D Models\">\n";
$_CONTEXT['media'] .= "<option value=\"model/example\">Defined in RFC 4735</option>\n";
$_CONTEXT['media'] .= "<option value=\"model/iges\">IGS files, IGES files; Defined in RFC 2077</option>\n";
$_CONTEXT['media'] .= "<option value=\"model/mesh\">MSH files, MESH files; Defined in RFC 2077, SILO files</option>\n";
$_CONTEXT['media'] .= "<option value=\"model/vrml\">WRL files, VRML files; Defined in RFC 2077</option>\n";
$_CONTEXT['media'] .= "<option value=\"model/x3d+binary\">X3D ISO standard for representing 3D computer graphics, X3DB binary files</option>\n";
$_CONTEXT['media'] .= "<option value=\"model/x3d+vrml\">X3D ISO standard for representing 3D computer graphics, X3DV VRML files</option>\n";
$_CONTEXT['media'] .= "<option value=\"model/x3d+xml\">X3D ISO standard for representing 3D computer graphics, X3D XML files</option>\n";
$_CONTEXT['media'] .= "</optgroup>\n";
$_CONTEXT['media'] .= "<optgroup label=\"Archives + Multipart\">\n";
$_CONTEXT['media'] .= "<option value=\"multipart/mixed\">MIME Email; Defined in RFC 2045 and RFC 2046</option>\n";
$_CONTEXT['media'] .= "<option value=\"multipart/alternative\">MIME Email; Defined in RFC 2045 and RFC 2046</option>\n";
$_CONTEXT['media'] .= "<option value=\"multipart/related\">MIME Email; Defined in RFC 2387 and used by MHTML (HTML mail)</option>\n";
$_CONTEXT['media'] .= "<option value=\"multipart/form-data\">MIME Webform; Defined in RFC 2388</option>\n";
$_CONTEXT['media'] .= "<option value=\"multipart/signed\">Defined in RFC 1847</option>\n";
$_CONTEXT['media'] .= "<option value=\"multipart/encrypted\">Defined in RFC 1847</option>\n";
$_CONTEXT['media'] .= "</optgroup>\n";
$_CONTEXT['media'] .= "<optgroup label=\"Source\">\n";
$_CONTEXT['media'] .= "<option value=\"text/cmd\">commands; subtype resident in Gecko browsers like Firefox 3.5</option>\n";
$_CONTEXT['media'] .= "<option value=\"text/css\">Cascading Style Sheets; Defined in RFC 2318</option>\n";
$_CONTEXT['media'] .= "<option value=\"text/csv\">Comma-separated values; Defined in RFC 4180</option>\n";
$_CONTEXT['media'] .= "<option value=\"text/html\">HTML; Defined in RFC 2854</option>\n";
$_CONTEXT['media'] .= "<option value=\"text/javascript (Obsolete)\">JavaScript</option>\n";
$_CONTEXT['media'] .= "<option value=\"text/plain\">Textual data; Defined in RFC 2046 and RFC 3676</option>\n";
$_CONTEXT['media'] .= "<option value=\"text/vcard\">vCard (contact information); Defined in RFC 6350</option>\n";
$_CONTEXT['media'] .= "<option value=\"text/xml\">Extensible Markup Language; Defined in RFC 3023</option>\n";
$_CONTEXT['media'] .= "</optgroup>\n";
$_CONTEXT['media'] .= "<optgroup label=\"Video\">\n";
$_CONTEXT['media'] .= "<option value=\"video/mpeg\">MPEG-1 video with multiplexed audio; Defined in RFC 2045 and RFC 2046</option>\n";
$_CONTEXT['media'] .= "<option value=\"video/mp4\">MP4 video; Defined in RFC 4337</option>\n";
$_CONTEXT['media'] .= "<option value=\"video/ogg\">Ogg Theora or other video (with audio); Defined in RFC 5334</option>\n";
$_CONTEXT['media'] .= "<option value=\"video/quicktime\">QuickTime video; Registered</option>\n";
$_CONTEXT['media'] .= "<option value=\"video/webm\">WebM Matroska-based open media format</option>\n";
$_CONTEXT['media'] .= "<option value=\"video/x-matroska\">Matroska open media format</option>\n";
$_CONTEXT['media'] .= "<option value=\"video/x-ms-wmv\">Windows Media Video; Documented in Microsoft KB 288102</option>\n";
$_CONTEXT['media'] .= "<option value=\"video/x-flv\">Flash video (FLV files)</option>\n";
$_CONTEXT['media'] .= "</optgroup>\n";
$_CONTEXT['media'] .= "<optgroup label=\"Vendor Specific\">\n";
$_CONTEXT['media'] .= "<option value=\"application/vnd.oasis.opendocument.text\">OpenDocument Text; Registered</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/vnd.oasis.opendocument.spreadsheet\">OpenDocument Spreadsheet; Registered</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/vnd.oasis.opendocument.presentation\">OpenDocument Presentation; Registered</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/vnd.oasis.opendocument.graphics\">OpenDocument Graphics; Registered</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/vnd.ms-excel\">Microsoft Excel files</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/vnd.openxmlformats-officedocument.spreadsheetml.sheet\">Microsoft Excel 2007 files</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/vnd.ms-powerpoint\">Microsoft Powerpoint files</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/vnd.openxmlformats-officedocument.presentationml.presentation\">Microsoft PPS 2007 files</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/vnd.openxmlformats-officedocument.wordprocessingml.document\">Microsoft Word 2007 files</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/vnd.mozilla.xul+xml\">Mozilla XUL files</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/vnd.google-earth.kml+xml\">KML files (e.g. for Google Earth)</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/vnd.google-earth.kmz\">KMZ files (e.g. for Google Earth)</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/vnd.dart\">Dart files</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/vnd.android.package-archive\">For download apk files.</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/vnd.ms-xpsdocument\">XPS document</option>\n";
$_CONTEXT['media'] .= "</optgroup>\n";
$_CONTEXT['media'] .= "<optgroup label=\"Non Standard\">\n";
$_CONTEXT['media'] .= "<option value=\"application/x-7z-compressed\">7-Zip compression format.</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/x-deb\">deb (file format), a software package format used by the Debian project</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/x-dvi\">device-independent document in DVI format</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/x-font-ttf\">TrueType Font No registered MIME type, but this is the most commonly used</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/x-javascript\">application/x-latex\">LaTeX files</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/x-mpegURL\">.m3u8 variant playlist</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/x-rar-compressed\">RAR archive files</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/x-shockwave-flash\">Adobe Flash files for example with the extension .swf</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/x-stuffit\">StuffIt archive files</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/x-tar\">Tarball files</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/x-www-form-urlencoded\">Form Encoded Data; Documented in HTML 4.01 Specification</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/x-xpinstall\">Add-ons to Mozilla applications (Firefox, Thunderbird, SeaMonkey)</option>\n";
$_CONTEXT['media'] .= "<option value=\"audio/x-aac\">.aac audio files</option>\n";
$_CONTEXT['media'] .= "<option value=\"audio/x-caf\">Apple's CAF audio files</option>\n";
$_CONTEXT['media'] .= "<option value=\"image/x-xcf\">GIMP image file</option>\n";
$_CONTEXT['media'] .= "<option value=\"text/x-gwt-rpc\">GoogleWebToolkit data</option>\n";
$_CONTEXT['media'] .= "<option value=\"text/x-jquery-tmpl\">jQuery template data</option>\n";
$_CONTEXT['media'] .= "<option value=\"text/x-markdown\">Markdown formatted text</option>\n";
$_CONTEXT['media'] .= "</optgroup>\n";
$_CONTEXT['media'] .= "<optgroup label=\"PKCS\">\n";
$_CONTEXT['media'] .= "<option value=\"application/x-pkcs12\">p12 files</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/x-pkcs12\">pfx files</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/x-pkcs7-certificates\">p7b files</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/x-pkcs7-certificates\">spc files</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/x-pkcs7-certreqresp\">p7r files</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/x-pkcs7-mime\">p7c files</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/x-pkcs7-mime\">p7m files</option>\n";
$_CONTEXT['media'] .= "<option value=\"application/x-pkcs7-signature\">p7s files</option>\n";
$_CONTEXT['media'] .= "</optgroup>\n";
$_CONTEXT['media'] .= "</select>\n";
?>