<?php
/* Enumerates usernames from a service

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 16-03-2019
*/
// sockets are required for this
if(!function_exists("socket_create")){
	die("This module requires sockets to be enabled. You can open your php.ini file and uncomment the socket extension(remove semicolon), save and restart your server.");
}
// set variable to be able to save a task
$_MODULE_C = "thc_en";
include_once("../../Includes/screen_header.php");
include_once($_PATHS['style_root']."/screen.php");
include_once($_PATHS['functions_root']."/scrn.php");
if(!function_exists("WriteF")){
	include_once($_PATHS['functions_root']."/fwrite.php");
}
// options
$sOptions = "<b>logging:</b> ".($_CONTEXT['log']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>silence:</b> ".($_CONTEXT['silent']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>verbose:</b> ".($_CONTEXT['verbose']==true ? "on" : "off")."\n";
// enumeration results file
$_CONTEXT['enumerate_results_file'] = "enumerations.php";
if(isset($_POST['submit'])){
	switch($_POST['submit']){
		// enumerate users
		case"Enumerate":
		// get all usernames
		if(isset($_POST['sEnumerateUsers'])){
			// get users from manually specified string
			if($_POST['sEnumerateUsers']!=""){
				$aUsers = explode(",",$_POST['sEnumerateUsers']);
			}
			else{
				die($sOut."No usernames specified.");
			}
		}
		elseif(isset($_POST['sWordlist'])){
			// get users froma  wordlist
			if(!function_exists("GetFilesByDirectory")){
				include($_PATHS['functions_root']."/getfilebydir.php");
			}
			if(false==($aExistingFiles = GetFilesByDirectory($_PATHS['wordlist_root']))){
				die($sOut."No files found.");
			}
			else{
				if(!in_array($_POST['sWordlist'],$aExistingFiles)){
					die($sOut."File doesn't exist.");
				}
				else{
					$aUsers = @file($_PATHS['wordlist_root']."/".$_POST['sWordlist']);
				}
			}
		}
		// filter usernames
		$_CONTEXT['users'] = array();
		for($x=0;$x<count($aUsers);$x++){
			$aUsers[$x] = @trim($aUsers[$x]);
			if(!$aUsers[$x] || $aUsers[$x]==""){
				continue;
			}
			$_CONTEXT['users'][] = $aUsers[$x];
		}
		if(false==($iUsers = @count($_CONTEXT['users']))){
			die($sOut."No valid users specified");
		}
		// validate port number
		$iPort = @intval($_POST['iPort']);
		if($iPort<1 || $iPort>65535){
			die($sOut."Invalid port specified");
		}
		include_once($_PATHS['includes_root']."/task_start.php");
		echo $sOut;
		break;
		// remove file
		case"Remove File":
		@include($_CONTEXT['enumerate_results_file']);
		echo $sOut;
		// set template for enumeration data
		$sTemplate = "<?php\n/* Enumeration results for THC_EN\n\nAuthor: Remco Kouw\nSite: http://www.hacksuite.com\nLast Edit: ".date($_CONTEXT['time_pattern'],time())."\n*/\nif(!defined('IN_SCRIPT')){\n\texit;\n}\n\$_CONTEXT['enumerate_results'] = array();\n";
		$iQueries = @count($_CONTEXT['enumerate_results']);
		$bUpdate = false;
		$iRecord = 0;
		if($iQueries!=0){
			// add old records
			for($x=0;$x<$iQueries;$x++){
				if($_CONTEXT['enumerate_results'][$x]['filename']==$_POST['sEnumerateResults']){
					$bUpdate = true;
					continue;
				}
				$sTemplate .= "\$_CONTEXT['enumerate_results'][".$iRecord."] = array();\n";
				$sTemplate .= "\$_CONTEXT['enumerate_results'][".$iRecord."]['host'] = \"".$_CONTEXT['enumerate_results'][$x]['host']."\";\n";
				$sTemplate .= "\$_CONTEXT['enumerate_results'][".$iRecord."]['protocol'] = \"".$_CONTEXT['enumerate_results'][$x]['protocol']."\";\n";
				$sTemplate .= "\$_CONTEXT['enumerate_results'][".$iRecord."]['time'] = \"".$_CONTEXT['enumerate_results'][$x]['time']."\";\n";
				$sTemplate .= "\$_CONTEXT['enumerate_results'][".$iRecord."]['filename'] = \"".$_CONTEXT['enumerate_results'][$x]['filename']."\";\n";
				$iRecord++;
			}
		}
		else{
			die("No records present in <b>".$_CONTEXT['enumerate_results']."</b>");
		}
		if($bUpdate){
			@unlink("results/".$_POST['sEnumerateResults']);
			if(!WriteF($_CONTEXT['enumerate_results_file'],$sTemplate."?>","w")){
				die("Failed to update enumeration file");
			}
			else{
				die("Successfully removed file properties");
			}
		}
		else{
			die("Specified file properties don't exist");
		}
		exit;
		break;
		// dump of open ports on hosts
		case"View File":
		echo $sOut;
		@include($_CONTEXT['enumerate_results_file']);
		if(!isset($_CONTEXT['enumerate_results'][0])){
			die("No records found in <b>".$_CONTEXT['enumerate_results']."</b>");
		}
		$bValidFile = false;
		$_CONTEXT['enumerate_properties'] = array();
		for($x=0;$x<count($_CONTEXT['enumerate_results']);$x++){
			// get enumeration properties
			if($_CONTEXT['enumerate_results'][$x]['filename']==$_POST['sEnumerateResults']){
				$bValidFile = true;
				$_CONTEXT['enumerate_properties'] = $_CONTEXT['enumerate_results'][$x];
				$_CONTEXT['enumerate_properties']['users'] = json_decode(file_get_contents("results/".$_POST['sEnumerateResults']),true);
				break;
			}
		}
		if($bValidFile){
			// dump enumeration properties
		 	echo"<table border=\"0\" cellspacing=\"3\" cellpadding=\"3\">\n";
		 	echo"<tr><th>protocol</th><th>host</th><th>users</th><th>time</th></tr>\n";
			$sEnumeratedAccounts = implode(", ",$_CONTEXT['enumerate_properties']['users']);
			echo"<tr><td>".$_CONTEXT['enumerate_properties']['protocol']."</td><td>".$_CONTEXT['enumerate_properties']['host']."</td><td>".($sEnumeratedAccounts!="" ? $sEnumeratedAccounts : "no enumerated accounts")."</td><td>".date($_CONTEXT['time_pattern'].' H:i:s',$_CONTEXT['enumerate_properties']['time'])."</td></tr>\n";
		 	echo"</table>\n";
		}
		else{
			die("No properties found for the specified file");
		}
		echo $sEnd;
		exit;
		break;
		// just show index
		default:
		echo $sOut;
		echo $sOptions;
		echo $sEnd;
		exit;
	}
}
else{
	echo $sOut;
	echo $sOptions;
	echo $sEnd;
	exit;
}
$_CONTEXT['valid'] = array();
// let's enumerate the target
$sTemplateNew = "";
echo Screen("<br>\n<b>Running..</b><p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
// spit fire...
flush();
ob_flush();
switch($_POST['sType']){
	/* smtp enumeration */
	case"smtp":
	include("protocols/smtp.php");
	break;
	/* ftp enumeration */
	case"ftp":
	include("protocols/ftp.php");
	break;
	default:
	include_once($_PATHS['includes_root']."/task_end.php");
	die(Screen("<p>Protocol not supported</p>\n".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
// write valid data $aValid wordt context valid users
$sFileName = time()."-".substr(md5(mt_rand(0,1000)),0,mt_rand(5,9)).".php";
if(!WriteF("results/".$sFileName,json_encode($_CONTEXT['valid']),"w")){
	echo Screen("<p>Failed to write enumerated users to <b>results/".$sFileName."</b></p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
}
else{
	// if file was successfully created, make a new template
	$sTemplate = "<?php\n/* Enumeration results for THC_EN\n\nAuthor: Remco Kouw\nSite: http://www.hacksuite.com\nLast Edit: ".date($_CONTEXT['time_pattern'],time())."\n*/\nif(!defined('IN_SCRIPT')){\n\texit;\n}\n\$_CONTEXT['enumerate_results'] = array();\n";
	@include($_CONTEXT['enumerate_results_file']);
	$iQueries = @count($_CONTEXT['enumerate_results']);
	if($iQueries!=0){
		// add old records
		for($x=0;$x<$iQueries;$x++){
			$sTemplate .= "\$_CONTEXT['enumerate_results'][".$x."] = array();\n";
			$sTemplate .= "\$_CONTEXT['enumerate_results'][".$x."]['host'] = \"".$_CONTEXT['enumerate_results'][$x]['host']."\";\n";
			$sTemplate .= "\$_CONTEXT['enumerate_results'][".$x."]['protocol'] = \"".$_CONTEXT['enumerate_results'][$x]['protocol']."\";\n";
			$sTemplate .= "\$_CONTEXT['enumerate_results'][".$x."]['time'] = \"".$_CONTEXT['enumerate_results'][$x]['time']."\";\n";
			$sTemplate .= "\$_CONTEXT['enumerate_results'][".$x."]['filename'] = \"".$_CONTEXT['enumerate_results'][$x]['filename']."\";\n";
		}
	}
	$sTemplateNew .= "\$_CONTEXT['enumerate_results'][".$iQueries."] = array();\n";
	$sTemplateNew .= "\$_CONTEXT['enumerate_results'][".$iQueries."]['host'] = \"".$_POST['sInput']."\";\n";
	$sTemplateNew .= "\$_CONTEXT['enumerate_results'][".$iQueries."]['protocol'] = \"".$_POST['sType']."\";\n";
	$sTemplateNew .= "\$_CONTEXT['enumerate_results'][".$iQueries."]['time'] = \"".$_CONTEXT['start_task']."\";\n";
	$sTemplateNew .= "\$_CONTEXT['enumerate_results'][".$iQueries."]['filename'] = \"".$sFileName."\";\n";
	if(!WriteF($_CONTEXT['enumerate_results_file'],$sTemplate.$sTemplateNew."?>","w")){
		echo Screen("<p>Failed to update enumeration data file</p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
	}
}
// update entry in background task file
include_once($_PATHS['includes_root']."/task_end.php");
echo $sEnd;
?>