<?php
/*
Handler for Shodan queries

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 31-01-2019
*/
set_time_limit(0);
session_cache_limiter('nocache');
header('Expires: '.gmdate('r',0));
header('Content-type: application/json');
$_DYNAMIC_ROOT = "../..";
include_once("../../header.php");
$aDataR = array();
$aDataR['jresult'] = false;
/* if user wants to delete or show a result file */
if(isset($_POST['iDelete']) || isset($_POST['iShow'])){
	if(isset($_POST['iDelete'])){
		$aDataR['jmessage'] = "No such record";
		$_CONTEXT['mandatory'] = array("queries.php","../../Functions/fwrite.php");
		for($x=0;$x<count($_CONTEXT['mandatory']);$x++){
			if(!IsThere($_CONTEXT['mandatory'][$x])){
				$aDataR['jmessage'] = $_CONTEXT['errors'][count($_CONTEXT['errors'])-1];
				die(json_encode($aDataR));
			}
			include($_CONTEXT['mandatory'][$x]);
		}
		if($_POST['iDelete']!=""){
			// find corresponding record
			$aNew = array();
			if(false==($iQueries = @count($_CONTEXT['shodan_queries']))){
				$aDataR['jmessage'] = "No queries found in queries.php";
			}
			else{
				$sNewData = "<?php\n/* Search results for using the Shodan API\n\nAuthor: Remco Kouw\nSite: http://www.hacksuite.com\nLast Edit: ".date($_CONTEXT['time_pattern'],time())."\n*/\nif(!defined('IN_SCRIPT')){\n\texit;\n}\n\$_CONTEXT['shodan_queries'] = array();\n";
				$bRecordFound = false;
				$iIndex = 0;
				for($x=0;$x<count($_CONTEXT['shodan_queries']);$x++){
					if($_CONTEXT['shodan_queries'][$x]['filename']!=$_POST['iDelete']){
						// not found in this array, move to the next until we find it
						$sNewData .= "\$_CONTEXT['shodan_queries'][".$iIndex."] = array();\n";
						$sNewData .= "\$_CONTEXT['shodan_queries'][".$iIndex."]['keyword'] = \"".$_CONTEXT['shodan_queries'][$x]['keyword']."\";\n";
						$sNewData .= "\$_CONTEXT['shodan_queries'][".$iIndex."]['tstamp'] = \"".$_CONTEXT['shodan_queries'][$x]['tstamp']."\";\n";
						$sNewData .= "\$_CONTEXT['shodan_queries'][".$iIndex."]['settype'] = \"".$_CONTEXT['shodan_queries'][$x]['settype']."\";\n";
						$sNewData .= "\$_CONTEXT['shodan_queries'][".$iIndex."]['filename'] = \"".$_CONTEXT['shodan_queries'][$x]['filename']."\";\n";
						$iIndex++;
					}
					else{
						$bRecordFound = true;
					}
				}
				$sNewData .= "?>";
				if($bRecordFound){
					if(!WriteF("queries.php",$sNewData,"w")){
						$aDataR['jmessage'] = "Failed to set properties for result file";
						die(json_encode($aDataR));
					}
					// we are already sure that the value doesn't contain any bad characters that could lead to unwanted removal of files
					@unlink("results/".$_POST['iDelete']);
					$aDataR['jmessage'] = "Successfully deleted file";
					$aDataR['jdeleted'] = $_POST['iDelete'];
				}
			}
		}
	}
	else{
		// dump result file
		@include("queries.php");
		$aDataR['jmessage'] = "Failed to find result file";
		if(false==($iQueries = @count($_CONTEXT['shodan_queries']))){
			$aDataR['jmessage'] = "No queries found in queries.php";
		}
		else{
			for($x=0;$x<$iQueries;$x++){
				// find the file and dump it
				if($_CONTEXT['shodan_queries'][$x]['filename']==$_POST['iShow']){
					$aDataR['jmessage'] = file_get_contents("results/".$_POST['iShow']);
					break;
				}
			}
		}
	}
	die(json_encode($aDataR));
}
/* beyond this point is mainly shodan query execution */
$_CONTEXT['mandatory'] = array("api/Shodan.php","key.php","queries.php","shodown.php","parse_functions.php");
for($x=0;$x<count($_CONTEXT['mandatory']);$x++){
	if(!IsThere($_CONTEXT['mandatory'][$x])){
		$aDataR['jmessage'] = $_CONTEXT['errors'][count($_CONTEXT['errors'])-1];
		die(json_encode($aDataR));
	}
	include($_CONTEXT['mandatory'][$x]);
}
$oClient = new Shodan($_CONTEXT['api']['key'],true);
$oHandler = new Shodown();
// did the user click on a next/previous page hyperlink?
if(isset($_POST['sPageEncoded'])){
	// this condition will be executed when the user clicks on a hyperlink(values are posted using POST(ajax) not GET) to go to a different page
	$sDataPageEncoded = @base64_decode(trim($_POST['sPageEncoded']));
	$aDataPageEncoded = explode(":",$sDataPageEncoded);
	if(@count($aDataPageEncoded)!=3){
		/*
		[0] = method
		[1] = search term or cached file(method = 12)
		[2] = page number
		*/
		$aDataR['jmessage'] = "Invalid content in base64 encoded string, expecting three values".var_export($aDataPageEncoded,true);
		die(json_encode($aDataR));
	}
	if(false==($_POST['iPage'] = @intval($aDataPageEncoded[2]))){
		// this is not the final validation, just a check if the number looks valid
		$aDataR['jmessage'] = "Invalid value for page";
		die(json_encode($aDataR));
	}
	$_POST['sQueryField'] = $aDataPageEncoded[1];
	$_POST['sShodanQueries'] = $aDataPageEncoded[1];
	$_POST['sMethod'] = $aDataPageEncoded[0];
}
else{
	// first page if user doesn't click on next or previous page
	$_POST['iPage'] = 1;
	if(isset($_POST['sShodanQueries'])){
		// load previous query method
		$_POST['sQueryField'] = $_POST['sShodanQueries'];
	}
}
// set some values, innocent until proven guilty...
$aDataR['jpage'] = $_POST['iPage'];
$aDataR['jresultperpage'] = $oHandler->GetMatches();
$aDataR['jtype'] = $_POST['sMethod'];
$oHandler->SetPage($_POST['iPage']);
if(isset($_POST['sQueryField'])){
	// doesn't apply to ports and protocols
	$oHandler->SetSearch($_POST['sQueryField']);
}
$oHandler->SetMethod($_POST['sMethod']);
if(isset($_POST['sMethod'])){
	switch($_POST['sMethod']){
		/* regular search */
		case"1":
		try{
			$aDataR['jmessage'] = @$oClient->Search(array('query' => $_POST['sQueryField']));
		}
		catch(Exception $e){
			$aDataR['jmessage'] = $e->getMessage();
			die(json_encode($aDataR));
		}
		break;
		/* host search with(out) filters */
		case"3":
		try{
			$aDataR['jmessage'] = @$oClient->ShodanHostSearch(array('query' => $_POST['sQueryField']));
		}
		catch(Exception $e){
			$aDataR['jmessage'] = $e->getMessage();
			die(json_encode($aDataR));
		}
		$aDataR['jresult'] = true;
		break;
		/* ip search */
		case"5":
		try{
			$aDataR['jmessage'] = @$oClient->ShodanHost(array('ip' => $_POST['sQueryField']));
		}
		catch(Exception $e){
			$aDataR['jmessage'] = $e->getMessage();
			die(json_encode($aDataR));
		}
		$aDataR['jresult'] = true;
		break;
		/* is honeypot check */
		case"8":
		try{
			$aDataR['jmessage'] = @$oClient->LabsHoneyscore(array('ip' => $_POST['sQueryField']));
		}
		catch(Exception $e){
			$aDataR['jmessage'] = $e->getMessage();
			die(json_encode($aDataR));
		}
		$aDataR['jresult'] = true;
		die(json_encode($aDataR));
		break;
		/* ports crawled */
		case"10":
		try{
			$aDataR['jmessage'] = @$oClient->ShodanPorts();
		}
		catch(Exception $e){
			$aDataR['jmessage'] = $e->getMessage();
			die(json_encode($aDataR));
		}
		$sData = "";
		for($x=0;$x<count($aDataR['jmessage']);$x++){
			if(false==($sService = getservbyport($aDataR['jmessage'][$x],"tcp"))){
				if(false==($sService = getservbyport($aDataR['jmessage'][$x],"udp"))){
					$sService = "<i>no value specified</i>";
				}
			}
			$sData .= "<b>".$aDataR['jmessage'][$x].":</b> ".$sService."<br />";
		}
		$aDataR['jresult'] = true;
		$aDataR['jmessage'] = $sData;
		// no need to parse any further, just send results back
		die(json_encode($aDataR));
		break;
		/* protocols available */
		case"11":
		try{
			$aDataR['jmessage'] = @$oClient->ShodanProtocols();
		}
		catch(Exception $e){
			$aDataR['jmessage'] = $e->getMessage();
			die(json_encode($aDataR));
		}
		$aDataR['jresult'] = true;
		// no need to parse any further, just send results back
		die(json_encode($aDataR));
		break;
		/* load previous query */
		case"12":
		@include("queries.php");
		if(!isset($_CONTEXT['shodan_queries'][0])){
			$aDataR['jmessage'] = "Invalid data in query file";
			die(json_encode($aDataR));
		}
		$aDataMatch = array();
		for($x=0;$x<count($_CONTEXT['shodan_queries']);$x++){
			// find the type of scan that was used to create this result set
			if($_CONTEXT['shodan_queries'][$x]['filename']==$_POST['sShodanQueries']){
				$aDataMatch = $_CONTEXT['shodan_queries'][$x];
				break;
			}
		}
		if(!isset($aDataMatch['filename'])){
			$aDataR['jmessage'] = "No such record found in queries.php";
			die(json_encode($aDataR));
		}
		$_POST['sMethod'] = $aDataMatch['settype'];
		$aDataR['jinitialmethod'] = $_POST['sMethod'];
		$sResultFile = "results/".$aDataMatch['filename'];
		// result file containing json encoded data from a previous search
		if(!file_exists($sResultFile)){
			$aDataR['jmessage'] = "No result file found";
			die(json_encode($aDataR));
		}
		$aDataR['jmessage']['matches'] = json_decode(file_get_contents($sResultFile),true);
		// keep result compatible, matches is set when there are multiple results, host search eg only has 1 result..this will set matches if there's just one result, so we can still loop through results 
		if(!isset($aDataR['jmessage']['matches']['matches'])){
			$aDataR['jmessage']['matches'] = array($aDataR['jmessage']['matches']);
		}
		else{
			$aDataR['jmessage']['matches'] = $aDataR['jmessage']['matches']['matches'];
		}
		break;
		/* invalid post data */
		default:
		die(json_encode($aDataR));
	}
	// save results first, because we will paginate the results afterwards
	if(isset($_POST['iSave']) && $_POST['iSave']==1){
		// attempt to write results file
		$sFileResults = $oHandler->GenerateFileName().".php";
		// include earlier searches if available
		@include("queries.php");
		// create template
		$sTemplate = "<?php\n/* Search results for using the Shodan API\n\nAuthor: Remco Kouw\nSite: http://www.hacksuite.com\nLast Edit: ".date($_CONTEXT['time_pattern'],time())."\n*/\nif(!defined('IN_SCRIPT')){\n\texit;\n}\n\$_CONTEXT['shodan_queries'] = array();\n";
		$iQueries = @count($_CONTEXT['shodan_queries']);
		if($iQueries!=0){
			// add old records
			for($x=0;$x<$iQueries;$x++){
				$sTemplate .= "\$_CONTEXT['shodan_queries'][".$x."] = array();\n";
				$sTemplate .= "\$_CONTEXT['shodan_queries'][".$x."]['keyword'] = \"".$_CONTEXT['shodan_queries'][$x]['keyword']."\";\n";
				$sTemplate .= "\$_CONTEXT['shodan_queries'][".$x."]['tstamp'] = \"".$_CONTEXT['shodan_queries'][$x]['tstamp']."\";\n";
				$sTemplate .= "\$_CONTEXT['shodan_queries'][".$x."]['settype'] = \"".$_CONTEXT['shodan_queries'][$x]['settype']."\";\n";
				$sTemplate .= "\$_CONTEXT['shodan_queries'][".$x."]['filename'] = \"".$_CONTEXT['shodan_queries'][$x]['filename']."\";\n";
			}
		}
		$sTemplate .= "\$_CONTEXT['shodan_queries'][".$iQueries."] = array();\n";
		$sTemplate .= "\$_CONTEXT['shodan_queries'][".$iQueries."]['keyword'] = \"".trim($_POST['sQueryField'])."\";\n";
		$sTemplate .= "\$_CONTEXT['shodan_queries'][".$iQueries."]['tstamp'] = \"".time()."\";\n";
		$sTemplate .= "\$_CONTEXT['shodan_queries'][".$iQueries."]['settype'] = \"".trim($_POST['sMethod'])."\";\n";
		$sTemplate .= "\$_CONTEXT['shodan_queries'][".$iQueries."]['filename'] = \"".$sFileResults."\";\n";
		$sTemplate .= "?>";
		// can we create a result file?
		if(!$oHandler->WriteF("results/".$sFileResults,json_encode($aDataR['jmessage']),"w")){
			$aDataR['jresult'] = false;
			$aDataR['jmessage'] = "Failed to save results";
			die(json_encode($aDataR));
		}
		else{
			// attempt to write new file properties to queries file
			if(!$oHandler->WriteF("queries.php",$sTemplate,"w")){
				$aDataR['jresult'] = false;
				$aDataR['jmessage'] = "Failed to set properties for result file";
				die(json_encode($aDataR));
			}
		}
	}
	if(!isset($_CONTEXT['parse_shodan_functions'][$_POST['sMethod']]) || $_CONTEXT['parse_shodan_functions'][$_POST['sMethod']]==""){
		// missing entry in parse_functions.php
		$aDataR['jmessage'] = "Missing parse function for this result";
	}
	else{
		// paginate current results, default is 10 records per page
		// you can change this setting by uncommenting the line below and changing its value
		// $oHandler->SetMatches(15);
		// keep it as low as possible in order to prevent memory issues
		if(!isset($aDataR['jmessage']['matches'])){
			$aDataR['jmessage']['matches'] = array($aDataR['jmessage']);
		}
		$iTotal = count($aDataR['jmessage']['matches']);
		$aDataR['jmessage']['matches'] = $oHandler->Paginate($aDataR['jmessage']['matches'],$_POST['iPage']);
		// create html page select data
		$aDataR['html'] = $oHandler->PaginateHTML($iTotal,$_POST['iPage']);
		// decide which parse function to use for generating result set 
		$aDataR['jmessage']['matches'] = $oHandler->{$_CONTEXT['parse_shodan_functions'][$_POST['sMethod']]}($aDataR['jmessage']['matches']);
		//die(var_dump($aDataR['jmessage']['matches']));
		$aDataR['jresult'] = true;
	}
}
echo json_encode($aDataR);
?>