<?php
/* Setup for converter options

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 11-04-2015
*/
$_OPT = 0;
$_CONVERT = array();
// cryptography
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "md5 encrypt";
$_CONVERT[$_OPT]['description'] = "Encrypts a string into a 32 bit hash";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['group'] = "cryptography";
$_CONVERT[$_OPT]['position'] = 0;
$_CONVERT[$_OPT]['function'] = "md5";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "sha1 encrypt";
$_CONVERT[$_OPT]['description'] = "Encrypts a string into a 40 bit hash";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['group'] = "cryptography";
$_CONVERT[$_OPT]['position'] = 1;
$_CONVERT[$_OPT]['function'] = "sha1";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "base64 encode";
$_CONVERT[$_OPT]['description'] = "Encodes a string to base64";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "cryptography";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 2;
$_CONVERT[$_OPT]['function'] = "base64_encode";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "base64 decode";
$_CONVERT[$_OPT]['description'] = "Decodes a base64 string";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "cryptography";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 3;
$_CONVERT[$_OPT]['function'] = "base64_decode";
$_OPT++;
// networking
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "ip to host";
$_CONVERT[$_OPT]['description'] = "Converts ip to host";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "networking";
$_CONVERT[$_OPT]['fieldnames'] = array("ip");
$_CONVERT[$_OPT]['position'] = 0;
$_CONVERT[$_OPT]['function'] = "gethostbyaddr";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "host to ip";
$_CONVERT[$_OPT]['description'] = "Converts host to ip";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "networking";
$_CONVERT[$_OPT]['fieldnames'] = array("host");
$_CONVERT[$_OPT]['position'] = 1;
$_CONVERT[$_OPT]['function'] = "gethostbyname";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "long to ip";
$_CONVERT[$_OPT]['description'] = "Converts long number to ip address";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "networking";
$_CONVERT[$_OPT]['fieldnames'] = array("long number");
$_CONVERT[$_OPT]['position'] = 2;
$_CONVERT[$_OPT]['function'] = "long2ip";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "ip to long";
$_CONVERT[$_OPT]['description'] = "Converts ip address to long number";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "networking";
$_CONVERT[$_OPT]['fieldnames'] = array("ip");
$_CONVERT[$_OPT]['position'] = 3;
$_CONVERT[$_OPT]['function'] = "ip2long";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "get dns records";
$_CONVERT[$_OPT]['description'] = "obtain all dns records from given host";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "networking";
$_CONVERT[$_OPT]['fieldnames'] = array("host");
$_CONVERT[$_OPT]['position'] = 4;
$_CONVERT[$_OPT]['function'] = "getdns";
$_OPT++;
// string functions
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "strip slashes";
$_CONVERT[$_OPT]['description'] = "Strips slashes in a string";
$_CONVERT[$_OPT]['type'] = array(1);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("text");
$_CONVERT[$_OPT]['position'] = 0;
$_CONVERT[$_OPT]['function'] = "stripslashes";
$_CONVERT[$_OPT]['nl2br'] = 1;
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "escape single quotes";
$_CONVERT[$_OPT]['description'] = "Escape single quotes in a string";
$_CONVERT[$_OPT]['type'] = array(1);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("text");
$_CONVERT[$_OPT]['position'] = 1;
$_CONVERT[$_OPT]['function'] = "escapesinglequotes";
$_CONVERT[$_OPT]['nl2br'] = 1;
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "escape double quotes";
$_CONVERT[$_OPT]['description'] = "Escape double quotes in a string";
$_CONVERT[$_OPT]['type'] = array(1);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("text");
$_CONVERT[$_OPT]['position'] = 2;
$_CONVERT[$_OPT]['function'] = "escapedoublequotes";
$_CONVERT[$_OPT]['nl2br'] = 1;
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "escape variables";
$_CONVERT[$_OPT]['description'] = "Escape variables in a string";
$_CONVERT[$_OPT]['type'] = array(1);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("text");
$_CONVERT[$_OPT]['position'] = 3;
$_CONVERT[$_OPT]['function'] = "escapevariables";
$_CONVERT[$_OPT]['nl2br'] = 1;
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "substring";
$_CONVERT[$_OPT]['description'] = "Works the same as substr in php";
$_CONVERT[$_OPT]['type'] = array(1,0,0);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("this text","start","length");
$_CONVERT[$_OPT]['position'] = 4;
$_CONVERT[$_OPT]['function'] = "substr";
$_CONVERT[$_OPT]['nl2br'] = 1;
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "string replace";
$_CONVERT[$_OPT]['description'] = "Works the same as str_replace in php";
$_CONVERT[$_OPT]['type'] = array(0,0,1);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("find","replace","in this text");
$_CONVERT[$_OPT]['position'] = 5;
$_CONVERT[$_OPT]['function'] = "str_replace";
$_CONVERT[$_OPT]['nl2br'] = 1;
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "string reverse";
$_CONVERT[$_OPT]['description'] = "Works the same as strrev in php";
$_CONVERT[$_OPT]['type'] = array(1);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 6;
$_CONVERT[$_OPT]['function'] = "strrev";
$_CONVERT[$_OPT]['nl2br'] = 1;
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "string to lower";
$_CONVERT[$_OPT]['description'] = "Works the same as strtolower in php";
$_CONVERT[$_OPT]['type'] = array(1);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 7;
$_CONVERT[$_OPT]['function'] = "strtolower";
$_CONVERT[$_OPT]['nl2br'] = 1;
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "string to upper";
$_CONVERT[$_OPT]['description'] = "Works the same as strtoupper in php";
$_CONVERT[$_OPT]['type'] = array(1);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 8;
$_CONVERT[$_OPT]['function'] = "strtoupper";
$_CONVERT[$_OPT]['nl2br'] = 1;
$_OPT++;
// file functions
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "get file content";
$_CONVERT[$_OPT]['description'] = "Fetches data from from a local file";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "file functions";
$_CONVERT[$_OPT]['fieldnames'] = array("path");
$_CONVERT[$_OPT]['position'] = 0;
$_CONVERT[$_OPT]['function'] = "file_get_contents";
$_CONVERT[$_OPT]['nl2br'] = 1;
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "view source";
$_CONVERT[$_OPT]['description'] = "source of a http file";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "file functions";
$_CONVERT[$_OPT]['fieldnames'] = array("http path");
$_CONVERT[$_OPT]['position'] = 1;
$_CONVERT[$_OPT]['function'] = "viewsource";
$_CONVERT[$_OPT]['nl2br'] = 1;
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "write to file";
$_CONVERT[$_OPT]['description'] = "write text to file";
$_CONVERT[$_OPT]['type'] = array(0,1);
$_CONVERT[$_OPT]['group'] = "file functions";
$_CONVERT[$_OPT]['fieldnames'] = array("location","text");
$_CONVERT[$_OPT]['position'] = 2;
$_CONVERT[$_OPT]['function'] = "writef";
$_OPT++;
// server info functions
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "phpinfo";
$_CONVERT[$_OPT]['description'] = "Fetches php configuration";
$_CONVERT[$_OPT]['type'] = array();
$_CONVERT[$_OPT]['group'] = "server info";
$_CONVERT[$_OPT]['fieldnames'] = array();
$_CONVERT[$_OPT]['position'] = 0;
$_CONVERT[$_OPT]['function'] = "phpinfo";
/* keep this for template purposes
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "";
$_CONVERT[$_OPT]['description'] = "";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "";
$_CONVERT[$_OPT]['fieldnames'] = array("");
$_CONVERT[$_OPT]['position'] = 0;
$_CONVERT[$_OPT]['function'] = "";
*/
?>