<?php
/* Scans a host on open ports

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 16-03-2019
*/
// sockets are required for this
if(!function_exists("socket_create")){
	die("This module requires sockets to be enabled. You can open your php.ini file and uncomment the socket extension(remove semicolon), save and restart your server.");
}
// set variable to be able to save a task
$_MODULE_C = "thc_xs";
include_once("../../Includes/screen_header.php");
include_once($_PATHS['module_default_root']."/ports.php");
include_once($_PATHS['module_default_root']."/sockets.php");
include_once($_PATHS['style_root']."/screen.php");
include_once($_PATHS['functions_root']."/scrn.php");
// options
$sOptions = "<b>logging:</b> ".($_CONTEXT['log']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>silence:</b> ".($_CONTEXT['silent']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>verbose:</b> ".($_CONTEXT['verbose']==true ? "on" : "off")."\n";
$sDataFile = "scan_data.php";
if(isset($_POST['submit'])){
	switch($_POST['submit']){
		// enter portscan in task list
		case"Scan":
		include_once($_PATHS['includes_root']."/task_start.php");
		echo $sOut;
		break;
		// remove file
		case"Remove File":
		@include($sDataFile);
		include_once($_PATHS['functions_root']."/fwrite.php");
		echo $sOut;
		// set template for scan data
		$sTemplate = "<?php\n/* Scan results for THC_XS\n\nAuthor: Remco Kouw\nSite: http://www.hacksuite.com\nLast Edit: ".date($_CONTEXT['time_pattern'],time())."\n*/\nif(!defined('IN_SCRIPT')){\n\texit;\n}\n\$_CONTEXT['scan_results'] = array();\n";
		$iQueries = @count($_CONTEXT['scan_results']);
		$bUpdate = false;
		$iRecord = 0;
		if($iQueries!=0){
			// add old records
			for($x=0;$x<$iQueries;$x++){
				if($_CONTEXT['scan_results'][$x]['filename']==$_POST['sScanResults']){
					$bUpdate = true;
					continue;
				}
				$sTemplate .= "\$_CONTEXT['scan_results'][".$iRecord."] = array();\n";
				$sTemplate .= "\$_CONTEXT['scan_results'][".$iRecord."]['domain'] = \"".$_CONTEXT['scan_results'][$x]['domain']."\";\n";
				$sTemplate .= "\$_CONTEXT['scan_results'][".$iRecord."]['host'] = \"".$_CONTEXT['scan_results'][$x]['host']."\";\n";
				$sTemplate .= "\$_CONTEXT['scan_results'][".$iRecord."]['protocol'] = \"".$_CONTEXT['scan_results'][$x]['protocol']."\";\n";
				$sTemplate .= "\$_CONTEXT['scan_results'][".$iRecord."]['time'] = \"".$_CONTEXT['scan_results'][$x]['time']."\";\n";
				$sTemplate .= "\$_CONTEXT['scan_results'][".$iRecord."]['filename'] = \"".$_CONTEXT['scan_results'][$x]['filename']."\";\n";
				$iRecord++;
			}
		}
		else{
			die("No records present in <b>".$sDataFile."</b>");
		}
		if($bUpdate){
			@unlink("results/".$_POST['sScanResults']);
			if(!WriteF($sDataFile,$sTemplate."?>","w")){
				die("Failed to update scan data file");
			}
			else{
				die("Successfully removed file properties");
			}
		}
		else{
			die("Specified file properties don't exist");
		}
		exit;
		break;
		// dump of open ports on hosts
		case"View File":
		echo $sOut;
		@include($sDataFile);
		if(!isset($_CONTEXT['scan_results'][0])){
			die("No records found in <b>".$sDataFile."</b>");
		}
		$bValidFile = false;
		$_CONTEXT['scan_properties'] = array();
		for($x=0;$x<count($_CONTEXT['scan_results']);$x++){
			// get scan properties
			if($_CONTEXT['scan_results'][$x]['filename']==$_POST['sScanResults']){
				$bValidFile = true;
				$_CONTEXT['scan_properties'] = $_CONTEXT['scan_results'][$x];
				$_CONTEXT['scan_properties']['ports'] = json_decode(file_get_contents("results/".$_POST['sScanResults']),true);
				break;
			}
		}
		if($bValidFile){
			// dump scan properties
		 	echo"<table border=\"0\" cellspacing=\"3\" cellpadding=\"3\">\n";
		 	echo"<tr><th>type</th><th>protocol</th><th>host</th><th>ports open</th><th>time</th></tr>\n";
			echo"<tr><td>".$_CONTEXT['scan_properties']['domain']."</td><td>".$_CONTEXT['scan_properties']['protocol']."</td><td>".$_CONTEXT['scan_properties']['host']."</td><td>".implode(", ",$_CONTEXT['scan_properties']['ports'])."</td><td>".date($_CONTEXT['time_pattern'].' H:i:s',$_CONTEXT['scan_properties']['time'])."</td></tr>\n";
		 	echo"</table>\n";
		}
		else{
			die("No properties found for the specified file");
		}
		echo $sEnd;
		exit;
		break;
		// just show index
		default:
		echo $sOut;
		echo $sOptions;
		echo $sEnd;
		exit;
	}
}
else{
	echo $sOut;
	echo $sOptions;
	echo $sEnd;
	exit;
}
// do some rough validation and fall through till we start the scanning
if(isset($_POST['sInput']) && $_POST['sInput']!=""){
	$aHosts = @explode(",",$_POST['sInput']);
}
else{
	die("No hostname specified.");
}
if(!isset($_CONTEXT['socket'][$_POST['sScan']])){
	die("Invalid value for scan.");
}
$_CONTEXT['scan_hosts'] = array();
$iValid = 0;
for($x=0;$x<count($aHosts);$x++){
	// support for ipv4 and ipv6 addresses scans
	if(@filter_var($aHosts[$x],FILTER_VALIDATE_IP,FILTER_FLAG_IPV4)){
		$_CONTEXT['scan_hosts'][$iValid] = array();
		$_CONTEXT['scan_hosts'][$iValid]['domain'] = $_CONTEXT['socket']['protocol_type'][0];
	}
	elseif(@filter_var($aHosts[$x],FILTER_VALIDATE_IP,FILTER_FLAG_IPV6)){
		$_CONTEXT['scan_hosts'][$iValid] = array();
		$_CONTEXT['scan_hosts'][$iValid]['domain'] = $_CONTEXT['socket']['protocol_type'][1];
	}
	else{
		continue;
	}
	$_CONTEXT['scan_hosts'][$iValid]['host'] = $aHosts[$x];
	$_CONTEXT['scan_hosts'][$iValid]['type'] = $_CONTEXT['socket'][$_POST['sScan']][0];
	$_CONTEXT['scan_hosts'][$iValid]['protocol'] = $_CONTEXT['socket'][$_POST['sScan']][1];
	$iValid++;
}
if(false==($iHosts = @count($_CONTEXT['scan_hosts']))){
	die("No valid hosts specified.");
}
$aPorts = array();
$_CONTEXT['scan'] = array();
$_CONTEXT['scan']['min'] = 0;
$_CONTEXT['scan']['max'] = 0;
if(isset($_POST['sManualPorts'])){
 	if($_POST['sManualPorts']!=""){
 	 	if(strpos($_POST['sManualPorts'],",")>0){
	 		$aPorts = @explode(",",$_POST['sManualPorts']);
	 		$_CONTEXT['scan']['max'] = count($aPorts);
	 		for($x=0;$x<$_CONTEXT['scan']['max'];$x++){
	 			$aPorts[$x] = intval(trim($aPorts[$x]));
	 		}
 		}
 	}
}
else{
	if(!isset($_CONTEXT['ports'][$_POST['sType']])){
	 	// if it's invalid we'll just scan 1-1024
		$_POST['sType'] = "registered";
	}
	$_CONTEXT['scan']['min'] = $_CONTEXT['ports'][$_POST['sType']][0];
	$_CONTEXT['scan']['max'] = $_CONTEXT['ports'][$_POST['sType']][1] - $_CONTEXT['ports'][$_POST['sType']][0];
}
// catch invalid setup
if($_CONTEXT['scan']['min']==$_CONTEXT['scan']['max']){
 	die("Invalid scan options specified, remember that if you use manual ports that you need <b>,</b> in order to separate values.");
}
echo Screen("<br>\n<b>Running..</b><p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
// spit fire...
flush();
ob_flush();
// let's scan the target
include_once($_PATHS['functions_root']."/fwrite.php");
$sTemplateNew = "";
// previous scan data
$sScanData = "scan_data.php";
@include($sScanData);
$iCurrentHost = isset($_CONTEXT['scan_results']) ? @count($_CONTEXT['scan_results']) : 0;
// every host
for($y=0;$y<$iHosts;$y++){
	if(false!==($rSocket = @socket_create(constant($_CONTEXT['scan_hosts'][$y]['domain']),constant($_CONTEXT['scan_hosts'][$y]['type']),constant($_CONTEXT['scan_hosts'][$y]['protocol'])))){
		$iOpen = 0;
		$_CONTEXT['open_ports'] = array();
		// every port
		for($x=$_CONTEXT['scan']['min'];$x<$_CONTEXT['scan']['max'];$x++){
			// try to connect to port
			$iPort = isset($_POST['sManualPorts']) ? $aPorts[$x] : $x;
			$rConnectS = @socket_connect($rSocket,$_CONTEXT['scan_hosts'][$y]['host'],$iPort);
			if($rConnectS){
				$iOpen++;
				$_CONTEXT['open_ports'][] = $iPort;
				// terminate socket
				socket_close($rSocket);
				// create new socket
				$rSocket = @socket_create(constant($_CONTEXT['scan_hosts'][$y]['domain']),constant($_CONTEXT['scan_hosts'][$y]['type']),constant($_CONTEXT['scan_hosts'][$y]['protocol']));
				echo Screen("[".$_CONTEXT['scan_hosts'][$y]['host'].":".$iPort."] - <b>OPEN</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			}
			else{
				echo Screen("[".$_CONTEXT['scan_hosts'][$y]['host'].":".$iPort."] - <b>CLOSED</b> - (".socket_strerror(socket_last_error()).")<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			}
			// send to browser
			flush();
			ob_flush();
		}
		$sFileName = time()."-".substr(md5(mt_rand(0,1000)),0,mt_rand(5,9)).".php";
		if(!WriteF("results/".$sFileName,json_encode($_CONTEXT['open_ports']),"w")){
			echo Screen("<p>Failed to write open port numbers to <b>results/".$sFileName."</b></p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		}
		else{
			// if file was successfully created, make a new template
			$sTemplateNew .= "\$_CONTEXT['scan_results'][".$iCurrentHost."] = array();\n";
			$sTemplateNew .= "\$_CONTEXT['scan_results'][".$iCurrentHost."]['domain'] = \"".($_CONTEXT['scan_hosts'][$y]['domain']=="AF_INET6" ? "ipv6" : "ipv4")."\";\n";
			$sTemplateNew .= "\$_CONTEXT['scan_results'][".$iCurrentHost."]['host'] = \"".$_CONTEXT['scan_hosts'][$y]['host']."\";\n";
			$sTemplateNew .= "\$_CONTEXT['scan_results'][".$iCurrentHost."]['protocol'] = \"".($_CONTEXT['scan_hosts'][$y]['protocol']=="SOL_TCP" ? "tcp" : "udp")."\";\n";
			$sTemplateNew .= "\$_CONTEXT['scan_results'][".$iCurrentHost."]['time'] = \"".$_CONTEXT['start_task']."\";\n";
			$sTemplateNew .= "\$_CONTEXT['scan_results'][".$iCurrentHost."]['filename'] = \"".$sFileName."\";\n";
			$iCurrentHost++;
		}
		echo Screen("</p><p><b>open ports for ".$_CONTEXT['scan_hosts'][$y]['host']."</b>: ".$iOpen." (running time) ".(time()-$_CONTEXT['start_task'])."(s)</p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
	
	}
	else{
		echo"Failed to create socket";
	}
}
// set template for scan data
$sTemplate = "<?php\n/* Scan results for THC_XS\n\nAuthor: Remco Kouw\nSite: http://www.hacksuite.com\nLast Edit: ".date($_CONTEXT['time_pattern'],time())."\n*/\nif(!defined('IN_SCRIPT')){\n\texit;\n}\n\$_CONTEXT['scan_results'] = array();\n";
$iQueries = @count($_CONTEXT['scan_results']);
if($iQueries!=0){
	// add old records
	for($x=0;$x<$iQueries;$x++){
		$sTemplate .= "\$_CONTEXT['scan_results'][".$x."] = array();\n";
		$sTemplate .= "\$_CONTEXT['scan_results'][".$x."]['domain'] = \"".$_CONTEXT['scan_results'][$x]['domain']."\";\n";
		$sTemplate .= "\$_CONTEXT['scan_results'][".$x."]['host'] = \"".$_CONTEXT['scan_results'][$x]['host']."\";\n";
		$sTemplate .= "\$_CONTEXT['scan_results'][".$x."]['protocol'] = \"".$_CONTEXT['scan_results'][$x]['protocol']."\";\n";
		$sTemplate .= "\$_CONTEXT['scan_results'][".$x."]['time'] = \"".$_CONTEXT['scan_results'][$x]['time']."\";\n";
		$sTemplate .= "\$_CONTEXT['scan_results'][".$x."]['filename'] = \"".$_CONTEXT['scan_results'][$x]['filename']."\";\n";
	}
}
if(!WriteF($sScanData,$sTemplate.$sTemplateNew."?>","w")){
	echo Screen("<p>Failed to update scan data file, this basically means that there are files not linked to ".$sScanData."</p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
}
// update entry in background task file
include_once($_PATHS['includes_root']."/task_end.php");
echo $sEnd;
?>