<?php
/*
Authentication checker

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 03-04-2019
*/
if(!defined('IN_SCRIPT')){
	exit;
}
if(!$_CONTEXT['ip_access'] && !$_CONTEXT['pass_access'] && basename($_SERVER['PHP_SELF'])!="setup.php"){
	if(!file_exists("setup.php")){
		die("You need to run the setup script first");
	}
	else{
		header("Location: setup.php");
		exit;
	}
}
if(!defined("PASS_WO_LOGIN")){
	// make sure we have any sort of authentication setup
	if(!@$_CONTEXT['pass_access']){
		if(!@$_CONTEXT['ip_access']){
			// as long as we don't have any type of authentication, redirect to setup
			header("Location: setup.php");
			exit;
		}
	}
	// block unauthorized ip access
	if(isset($_CONTEXT['ip_access']) && $_CONTEXT['ip_access']){
		if(in_array($_SERVER['REMOTE_ADDR'],$_CONTEXT['ip_allowed'])){
			$bLoggedTHC = true;
		}
	}
	// block unauthorized access without a password specified
	if(isset($_CONTEXT['pass_access']) && $_CONTEXT['pass_access']==true){
		$sCookieName = "thcauth_".substr($_CONTEXT['pass_hash'],0,5);
		if(!isset($_COOKIE[$sCookieName])){
			header("Location: ".($_PATHS['root'][0]=="." ? $_PATHS['root'] : $_PATHS['root_http'])."/login.php");
			exit;
		}
		$bLoggedTHC = ($_COOKIE[$sCookieName]==$_CONTEXT['pass_hash'] ? true : false); 
	}
	if(!$bLoggedTHC){
		// redirect on login failure
		header("Location: ".$_CONTEXT['redirect_fail_login']);
		exit;
	}
}
?>